/* Copyright (c) 2001-2009 by SoftIntegration, Inc. All Rights Reserved */
#include <stdio.h>
#include <ch.h>

typedef void (*funcHandle)(); /* function pointer type */

/* C functions to replace the Ch one */
static ChInterp_t interp;
static void setFunction1_chdl_funarg();

/* function pointers to save Ch function pointers */
static void *setFunction1_chdl_funptr;

EXPORTCH void setFunction1_chdl(void *varg){
  ChVaList_t ap;
  int arg1;
  funcHandle handle_ch, handle_c = NULL;

  Ch_VaStart(interp, ap, varg);
  arg1 = Ch_VaArg(interp, ap, int);
  handle_ch = Ch_VaArg(interp, ap, funcHandle); /* get ch function pointer */
  setFunction1_chdl_funptr = (void *)handle_ch;

  /* replace the Ch function pointer with the C one,
     the NULL pointer can't be replaced */
  if(handle_ch != NULL) {
    handle_c = (funcHandle)setFunction1_chdl_funarg;
  }

  setFunction1(arg1, handle_c);
  Ch_VaEnd(interp, ap);
}

static void setFunction1_chdl_funarg() {
  Ch_CallFuncByAddr(interp, setFunction1_chdl_funptr, NULL);
}
